#! /usr/bin/env node

const path = require('path')
const Artisanft = require('artisanft')

console.log()
console.log('\x1b[34m', '**************************************************************', '\x1b[0m')
console.log('\x1b[36m', '******************** Welcome to Ideo Node ********************', '\x1b[0m')
console.log('\x1b[34m', '**************************************************************', '\x1b[0m')
console.log()

// presentation
Artisanft.Logger.logTask('mysql')
Artisanft.Logger.logInfo('Add mysql support to the project.')

// copy template files
Artisanft.Logger.logActionInit('Copy template files')
Artisanft.FileSystem.copyAllSync(path.join(__dirname, '../templates/mysql'))
Artisanft.Logger.logActionEnd('Copy template files')

// install mysql dependencies
Artisanft.Logger.logActionInit('Install mysql dependencies')
Artisanft.Npm.installSync('mysql', './lib/mysql')
Artisanft.Logger.logActionEnd('Install mysql dependencies')

// add custom scripts
Artisanft.Logger.logActionInit('Add scripts to package.json')
Artisanft.PackageJson.addScriptSync('mysql:schema', 'node ./bin/mysqlSchema')
Artisanft.Logger.logActionEnd('Add scripts to package.json')
