/**
 * This is the main file of the server.
 * Set here all server routes to start to work.
 */

const browserSync  = require('browser-sync')
const config = require('./config')
const app = require('./lib/express')
const ApplicationController = require('./app/controllers/ApplicationController')
const isProduction = config.environment === 'production'

// Routes.
app.get('/', ApplicationController.index)

// Production
if (isProduction) {
  app.listen(config.port, function() {});
} else {
  browserSync.create().init({
    server: './public',
    files: [
      './app/views/**/*.pug',
      './public/**',
    ],
    middleware: [app],
    open: false,
    notify: false,
    reloadOnRestart : true,
  });
}