/**
 * @description This file is a merge of environment configurations and default configurations.
 */

const path = require('path')

// Find current environment.
const environment = process.env.NODE_ENV || 'development'

// Find environment configurations.
const envConfigs = require(`./environments/${environment}.json`)

// Set default configurations.
const defaultConfigs = {

  // current environment
  environment: environment,

  // current root path
  root: path.resolve(__dirname, '../'),

  // server port
  port: process.env.PORT || 3000,

}

// Create config object.
const config = Object.assign(defaultConfigs, envConfigs)

module.exports = config
