#! /usr/bin/env node

/**
 * Create the application database.
 */

const mysql = require('../lib/mysql')

// List of queries.
const createTodosTable = `
CREATE TABLE IF NOT EXISTS todos (
  uuid varchar(36) NOT NULL,
  name varchar(250) NOT NULL,
  PRIMARY KEY (uuid)
)
`

// Run queries.
mysql.startQueries()
  .then(() => {
    return mysql.query(createTodosTable)
  })
  .then(() => {
    return mysql.closePool()
  })
  .then(() => {
    console.log('Schema completed! :)')
  })
  .catch((error) => {
    console.log(error)
  })
